<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FlightRate ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FlightRate extends AbstractStructArrayBase
{
    /**
     * The FlightRate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FlightRate[]
     */
    public $FlightRate;
    /**
     * Constructor method for ArrayOfJP_FlightRate
     * @uses ArrayOfJP_FlightRate::setFlightRate()
     * @param \StructType\JP_FlightRate[] $flightRate
     */
    public function __construct(array $flightRate = array())
    {
        $this
            ->setFlightRate($flightRate);
    }
    /**
     * Get FlightRate value
     * @return \StructType\JP_FlightRate[]|null
     */
    public function getFlightRate()
    {
        return $this->FlightRate;
    }
    /**
     * This method is responsible for validating the values passed to the setFlightRate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFlightRate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFlightRateForArrayConstraintsFromSetFlightRate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_FlightRateFlightRateItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FlightRateFlightRateItem instanceof \StructType\JP_FlightRate) {
                $invalidValues[] = is_object($arrayOfJP_FlightRateFlightRateItem) ? get_class($arrayOfJP_FlightRateFlightRateItem) : sprintf('%s(%s)', gettype($arrayOfJP_FlightRateFlightRateItem), var_export($arrayOfJP_FlightRateFlightRateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FlightRate property can only contain items of type \StructType\JP_FlightRate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FlightRate value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FlightRate[] $flightRate
     * @return \ArrayType\ArrayOfJP_FlightRate
     */
    public function setFlightRate(array $flightRate = array())
    {
        // validation for constraint: array
        if ('' !== ($flightRateArrayErrorMessage = self::validateFlightRateForArrayConstraintsFromSetFlightRate($flightRate))) {
            throw new \InvalidArgumentException($flightRateArrayErrorMessage, __LINE__);
        }
        $this->FlightRate = $flightRate;
        return $this;
    }
    /**
     * Add item to FlightRate value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FlightRate $item
     * @return \ArrayType\ArrayOfJP_FlightRate
     */
    public function addToFlightRate(\StructType\JP_FlightRate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FlightRate) {
            throw new \InvalidArgumentException(sprintf('The FlightRate property can only contain items of type \StructType\JP_FlightRate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FlightRate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FlightRate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FlightRate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FlightRate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FlightRate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FlightRate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightRate
     */
    public function getAttributeName()
    {
        return 'FlightRate';
    }
}
